package net.rzdata.exception;

public abstract sealed class BaseException extends RuntimeException
    permits ClientException, ServerException, ThirdPartyException {

    private final String code;

    protected BaseException(String code, String message) {
        super(message);
        this.code = code;
    }

    protected BaseException(String code, String message, Throwable cause) {
        super(message, cause);
        this.code = code;
    }

    public String getCode() {
        return this.code;
    }
}
