package net.rzdata.demo.dict;

import net.rzdata.demo.dict.domain.AddDictReq;
import net.rzdata.demo.dict.domain.Dict;
import net.rzdata.demo.dict.domain.UpdateDictReq;
import net.rzdata.domain.Id;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/dict")
public class DictController {

    private final DictService dictService;

    public DictController(DictService dictService) {
        this.dictService = dictService;
    }

    @PostMapping()
    public Id addDict(@RequestBody AddDictReq req) {
        Dict dict = req.into();
        if (dict.getParentId() == null) {
            dict.setParentId(Dict.ROOT.getId());
            dict.setType(Dict.ROOT.getType());
        }
        dictService.addDict(dict);
        return Id.of(dict.getId());
    }

    @PutMapping()
    public Id updateDict(@RequestBody UpdateDictReq req) {
        Dict dict = req.into();
        dictService.updateDict(dict);
        return Id.of(dict.getId());
    }
}
