package net.rzdata.demo.dict.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.*;
import net.rzdata.demo.trait.TreeNode;

import java.util.Collections;
import java.util.List;

/**
 * 字典
 */
@Getter
@Setter
@ToString
@NoArgsConstructor
@AllArgsConstructor
public class Dict implements TreeNode<Dict, String> {

    public static final Dict ROOT = new Dict("0", "字典", "dict", "dict", 0, false, "0", Collections.emptyList());

    /**
     * 字典主键
     */
    @TableId(type = IdType.ASSIGN_ID)
    String id;
    /**
     * 字典标签
     */
    String label;
    /**
     * 字典键值
     */
    String value;
    /**
     * 字典类型
     */
    String type;
    /**
     * 字典排序
     */
    Integer sort;
    /**
     * 是否停用
     */
    Boolean disabled;
    /**
     * 父节点ID
     */
    String parentId;
    /**
     * 子节点
     */
    @TableField(exist = false)
    List<Dict> children;
}
